# Connexion  la base de donnes relationnelle type Acess

#
#                            Install Package
#_______________________________________________________________________________
require (RODBC) # le package RODBC permet la connexion  une base de bonnes relationnelle
#
#                            Set connection to database
#_______________________________________________________________________________  
# !!! Note: les tapes peuvent varier en fonction de votre ordinateur !!!
# !!! la configuration de votre panneau de comande est particulirement importante !!!
# 1) Ouvrir le Panneau de configuration de votre ordi
#    Pour le touver facilement presser la Touche Windows + R puis taper "control" dans la fentre. 
# 2) Ouvrir le panneau "Outils d'administration"
# 3) Cliquez sur "Sources de donnes (ODBC)"
#    Dans l'onglet "Sources de donnes utilisateur" choisir "MS Acess Database" puis cliquez sur "Ajouter"
# 4) Choisir l'option "Microsoft Acess Driver (*.mdb, *.accdb)"
# 5) Nommer votre base de donne (ex: "ExOiseaux") 
#    Cliquez sur slectionner
#    Choisir votre base de donne
#    !!! Note les chemins compliqus peuvent causer dees erreurs. Le mieux est peut-tre de mettre votre base de donnes 
#    directement sur votre disque dur (ex: C:\)!!!
# 6) Cliquez sur Ok... Cliquez sur Ok .. voil!
#
#                            delete connection to database
#_______________________________________________________________________________   
# 1) Touche Windows + R puis taper "control"
# 2) Panneau "Outils d'administration"
# 3) Cliquez sur "Sources de donnes (ODBC)"
# 4) Choissisez la base de donne  effacer (Ex: "ExOiseaux")
# 5) Presser "Supprimer" !!! Assurez vous de NE PAS EFFACER les autres sources de contrle" !!!
#
#                            Set connection in R
#_______________________________________________________________________________ 
Channel.1 <- odbcConnect("ExOiseaux")  # Permet de faire le lien entre R et la base de donnes
Channel.1 # Vrifier la connexion
sqlTables(Channel.1)  # Afficher toutes les tables de la base de donnes
# Les Tables qui vous intressent vont tre identifies "TABLE" dans la colonne "TABLE_TYPE"
# Les tables identifies "SYSTEM TABLE" ne vous intressent probablement pas... 
#
#                            importer des tables dans R
#_______________________________________________________________________________ 
coordonnees<-(sqlFetch(Channel.1 ,"StationXY")) # Importer la table "Station XY"
head(coordonnees)
str(coordonnees)
plot(coordonnees$X, coordonnees$Y)

    
vegetation<-(sqlFetch(Channel.1 ,"VegetationStation")) # Importer la table "VegetationStation"
head(vegetation)
str(vegetation)    
plot(vegetation$Trait,vegetation$SNAG)   
   

especes<-(sqlFetch(Channel.1 ,"AbondanceOiseaux2007")) # Importer la table ""AbondanceOiseaux2007""
head(especes)
str(especes)
plot(especes$Trait,especes$JUAR)
#
#     Requtes - adpater le language SQL  celui de R / combiner les tables
#_______________________________________________________________________________ 
#Si vous utilisez le langage directement dans R, il VA y avoir un conflit entre R et SQL au niveau 
#des guillemets si vous n'tes pas prudent. Assurez-vous d'utiliser les guillemets simples (i.e. ' ) 
#pour un langage et les guillemets doubles pour l'autre (i.e. ").

#Si vous n'tes pas familier avec le langage SQL vous pouvez faire vos requtes dans Acess  et 
#importer le texte SQL en utilisant la fonction SQL direct. Copier-coller simplement le texte 
#gnr. Encore une fois portez attention aux guillemets.



#***************************** Requte 1******************************#
# Table qui contient l'abondance de certaines espces slectionnes et 
# et les variables de vgtations 
AbondOi<-sqlQuery(Channel.1, 'SELECT StationXY.X, 
                                     StationXY.Y, 
                                     VegetationStation.CWD
                                     FROM StationXY INNER JOIN VegetationStation 
                                     ON StationXY.ID = VegetationStation.ID')

AbondOi[1:4,]
   
#***************************** Requte 2******************************#
# Table qui contient l'abondance de ROCR suprieur  deux et le nombre de
# chicot dans les stations 
   
ROCR3.Snag <- sqlQuery(Channel.1 ,'SELECT AbondanceOiseaux2007.Trait, 
                                          AbondanceOiseaux2007.Habitat, 
                                          AbondanceOiseaux2007.Stations, 
                                          AbondanceOiseaux2007.ROCR, 
                                          VegetationStation.CC, 
                                          VegetationStation.SNAG, 
                                          VegetationStation.T
                                          FROM AbondanceOiseaux2007 INNER JOIN 
                                          VegetationStation ON AbondanceOiseaux2007.ID = VegetationStation.ID 
                                          WHERE (((AbondanceOiseaux2007.ROCR)>2))')



ROCR3.Snag [1:4,]
  
#***************************** Requte 3 ******************************#
# Table avec calcul- Calcul la moyenne d'arbres par habitat
  
MTH <- sqlQuery(Channel.1 ,'SELECT StationXY.ID, 
                                   VegetationStation.Habitat, 
                                   VegetationStation.Trait, 
                                   VegetationStation.Dispo, 
                                   Avg(VegetationStation.T) 
                                   AS MoyenneDeT FROM StationXY INNER JOIN 
                                   (VegetationStation INNER JOIN PresenceAbsence2007 ON VegetationStation.ID = PresenceAbsence2007.ID) 
                                   ON StationXY.ID = VegetationStation.ID GROUP BY StationXY.ID, 
                                   VegetationStation.Habitat, VegetationStation.Trait, VegetationStation.Dispo')


MTH [1:4,]
#
#                       Sauver une table dans la base de donnes
#_______________________________________________________________________________
#sqlSave

#
#                !!!  liminer des tables DANS LA BASE DE DONNES !!!!
#_______________________________________________________________________________ 
### Pour liminer un objet DANS R utliser rm()
mveg<-(sqlFetch(Channel.1 ,"microvegetation"))
head(mveg)
ls()
rm(mveg) # Efface mveg dans R
ls()     # mveg n'apparat plus
### Maintenant pour effacer de manire PERMANENTE une table DANS la base de donnes
sqlDrop(Channel.1,"microvegetation") ###   !!! limine une table de la base de donnes !!!
sqlTables(Channel.1)  # Imprimer toutes les tables de la base de donnes mais 
# la table microvegetation n'apparat plus
#
#                            Fermer la connection  (optionnel)
#_______________________________________________________________________________   
odbcClose(Channel.1) #  permet de librer de la mmoire.
